$!-----------------------------------------------------------------------------
$! UPDATE_PURGE.COM
$!
$! Copyright (C) 1996-2024 Mark G.Daniel.
$!
$! Licensed under the Apache License, Version 2.0 (the "License");
$! you may not use this file except in compliance with the License.
$! You may obtain a copy of the License at
$!
$!    http://www.apache.org/licenses/LICENSE-2.0
$!
$! Unless required by applicable law or agreed to in writing, software
$! distributed under the License is distributed on an "AS IS" BASIS,
$! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
$! See the License for the specific language governing permissions and
$! limitations under the License.
$!
$! Clean up (purge) files from previous versions, excluding selected files,
$! and then rename back to ;1.
$!
$! 20-DEC-2022  MGD  initial
$!-----------------------------------------------------------------------------
$ set noon
$ arch_name = f$edit(f$getsyi("arch_name"),"upcase") 
$ if arch_name .eqs. "ALPHA" then arch_name = "AXP"
$ delete = "delete"
$!
$ if f$trnlnm("INSTALL$DBUG") .nes. "" then set verify
$!
$ if f$environment("depth") .eq. 1 then write sys$output ""
$!
$ type sys$input
                      *********************************
                      *  PURGE PREVIOUS INSTALLATION  *
                      *********************************

This procedure cleans up (purges) selected files from previous installations.

It then renames those same files from ;0 to ;1

                            *********************
                            *  CONTINUE PURGE?  *
                            *********************

$ response = ""
$ read sys$command response /prompt="Continue? [NO]: "
$ say ""
$ if .not. response then exit
$!
$ purge = "purge/nolog/noconfirm"
$ rename = "rename/nolog/noconfirm"
$!
$ type sys$input
                                 ***********
                                 *  .C .H  *
                                 ***********

$ purge wasd_root:[000000...]*.c,*.h
$ rename wasd_root:[000000...]*.c;0,*.h;0 ;1
$ type sys$input
                               ***************
                               *  .OBJ .OLB  *
                               ***************

$ purge wasd_root:[000000...]*.obj,*.olb
$ rename wasd_root:[000000...]*.obj;0,*.olb;0 ;1
$ type sys$input
                               ***************
                               *  .COM .EXE  *
                               ***************

$ purge wasd_root:[000000...]*.com,*.exe
$ rename wasd_root:[000000...]*.com;0,*.exe;0 ;1
$ type sys$input
                             *******************
                             *  .HTML .WASDOC  *
                             *******************

$ purge wasd_root:[000000...]*.html,*.wasdoc
$ rename wasd_root:[000000...]*.html;0,*.wasdoc;0 ;1
$ type sys$input
                          *************************
                          *  .GIF .PNG .ICO .TXT  *
                          *************************

$ purge wasd_root:[000000...]*.gif,*.ico,*.png,*.txt
$ rename wasd_root:[000000...]*.gif;0,*.ico;0,*.png;0,*.txt;0 ;1
$ type sys$input
                        ****************************
                        *  PURGE  C O M P L E T E  *
                        ****************************

$!-----------------------------------------------------------------------------
