#
# Makefile to build WASD on VMS
# This file must be invoked from the [.src] directory of this package using MMS/EXT (MMK won't work)
#
# This procedure accepts several macros.  See setup.mms for details.
# This procedure requires SET PROCESS/PARSE_STYLE=EXTENDED to be set.
# (appears to be a requirement for multi-named build targets and for mixed-case object libraries)
#
.INCLUDE [.mms]constants.mms
.INCLUDE [.mms]libraries.mms

EXTRAFLAGS = /FIRST=$(OBJDIR)FIRST.H

#
# build setup ...
#
.FIRST
	@ IF F$SEARCH ("$(BLD_SETUP_FUNC)") .NES. "" THEN @$(BLD_SETUP_FUNC) "$(X86)" "$(SSL)"
	@ $!
	@ IF F$PARSE("$(OBJDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(OBJDIR)
	@ IF F$PARSE("$(AGENTOBJDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(AGENTOBJDIR)
	@ IF F$PARSE("$(CGIPLUSOBJDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(CGIPLUSOBJDIR)
	@ IF F$PARSE("$(CONANOBJDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(CONANOBJDIR)
	@ IF F$PARSE("$(EXPATOBJDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(EXPATOBJDIR)
	@ IF F$PARSE("$(HTTPDOBJDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(HTTPDOBJDIR)
	@ IF F$PARSE("$(HYPERREADEROBJDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(HYPERREADEROBJDIR)
	@ IF F$PARSE("$(MISCOBJDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(MISCOBJDIR)
	@ IF F$PARSE("$(OSUOBJDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(OSUOBJDIR)
	@ IF F$PARSE("$(QUERYOBJDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(QUERYOBJDIR)
	@ IF F$PARSE("$(SCREPEROBJDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(SCREPEROBJDIR)
	@ IF F$PARSE("$(UTILSOBJDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(UTILSOBJDIR)
	@ IF F$PARSE("$(WASDOCOBJDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(WASDOCOBJDIR)
	@ IF F$PARSE("$(WEBSOCKETOBJDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(WEBSOCKETOBJDIR)
	@ $!
	@ IF F$PARSE("$(LISDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(LISDIR)
	@ IF F$PARSE("$(LIBDIR)") .EQS. "" THEN CREATE/DIRECTORY/PROTECTION=(S:RWED,O:RWED) $(LIBDIR)
	@ IF F$SEARCH("$(LIBEXPAT)") .EQS. "" THEN $(LIBR)/CREATE $(LIBEXPAT)
	@ IF F$SEARCH("$(LIBHTTPD)") .EQS. "" THEN $(LIBR)/CREATE $(LIBHTTPD)
	@ IF F$SEARCH("$(LIBMISC)") .EQS. "" THEN $(LIBR)/CREATE $(LIBMISC)
	@ IF F$SEARCH("$(LIBMISC_AS_IS)") .EQS. "" THEN $(LIBR)/CREATE $(LIBMISC_AS_IS)
	@ IF F$SEARCH("$(LIBMISC_UPPER)") .EQS. "" THEN $(LIBR)/CREATE $(LIBMISC_UPPER)
	@ IF F$SEARCH("$(LIBOSU)") .EQS. "" THEN $(LIBR)/CREATE $(LIBOSU)
	@ IF F$SEARCH("$(LIBWASDOC)") .EQS. "" THEN $(LIBR)/CREATE $(LIBWASDOC)
	@ $!
	@ DEFINE/NOLOG DECC$USER_INCLUDE [.httpd],[.misc]
	@ LIB_SSL_32 = F$PARSE(F$TRNLNM("OPENSSL"),,,"DIRECTORY","NO_CONCEAL") - "]["
	@ $!
	@ target := $(MMSTARGETS)
	@ if target .eqs. "" then target = "BUILD"
	@ if target .eqs. "BUILD" then $(ECHO) "[ Building WASD ''IMAGE_IDENT' for $(PLATFORM) ]"
	@ $(ECHO) ""

#
# build wrapup ...
#
.LAST
        @ $(ECHO) ""
        @ if target .eqs. "BUILD" then $(ECHO) "[ WASD ''IMAGE_IDENT' build complete ]"
        @ $(ECHO) ""

#
# Define every executable to be built
#
AGENTS = $(WASD_EXE)AUTHAGENT_CEL.EXE $(WASD_EXE)AUTHAGENT_EXAMPLE.EXE $(WASD_EXE)AUTHAGENT_LDAP.EXE $(WASD_EXE)ACCAGENT.EXE \
	$(WASD_EXE)LOOKAGENT.EXE $(WASD_EXE)METAGENT.EXE

CGIPLUS = $(WASD_EXE)CGIPLUSDEMO.EXE $(WASD_EXE)CGIPLUSLOOP.EXE $(WASD_EXE)CGIPLUSSKEL.EXE $(WASD_EXE)CGICALLOUT.EXE \
	$(WASD_EXE)CGIPLUSCALLOUT.EXE $(WASD_EXE)CGISAPI.EXE $(WASD_EXE)CGIPLUSTEST.EXE $(WASD_EXE)ISAPIEXAMPLE.DLL \
	$(WASD_EXE)RTE_EXAMPLE.EXE

HTTPD = $(WASD_EXE)HTTPD_SSL.EXE $(CGI_EXE)CGILIBSHR32.EXE

MISC1 =	$(WASD_EXE)CONAN.EXE $(WASD_EXE)HYPERREADER.EXE $(WASD_EXE)HYPERSHELF.EXE
MISC2 =	$(WASD_EXE)CGILIB_EXAMPLE.EXE $(WASD_EXE)CGIUTL.EXE $(WASD_EXE)CHKACC.EXE $(WASD_EXE)FETCH.EXE $(WASD_EXE)FORMWORK.EXE \
	$(WASD_EXE)IPCTICKLER.EXE $(WASD_EXE)LINER.EXE $(WASD_EXE)MEMBUFDEMO.EXE $(WASD_EXE)TMAILER.EXE $(WASD_EXE)REPORTERROR.EXE

MISC3 =	$(WASD_EXE)SADHOC.EXE $(WASD_EXE)SHTTPDMON.EXE $(WASD_EXE)SMONITOR.EXE $(WASD_EXE)SOPCOM.EXE

OSU =	$(WASD_EXE)CGI_SYMBOLS.EXE $(WASD_EXE)CGI-MAILTO.EXE $(WASD_EXE)HTML_PREPROC.EXE $(WASD_EXE)SET_DCL_ENV.EXE \
	$(WASD_EXE)OSU_TESTCGI.EXE $(WASD_EXE)OSU_TESTFORM.EXE $(WASD_EXE)TMAIL.EXE $(WASD_EXE)VMSHELPGATE.EXE \
	$(WASD_EXE)WEBBOOK.EXE

QUERY =	$(WASD_EXE)EXTRACT.EXE $(WASD_EXE)QUERY.EXE

UTILS = $(WASD_EXE)CALOGS.EXE $(WASD_EXE)CSPREPORT.EXE $(WASD_EXE)GEOLOCATE.EXE $(WASD_EXE)HTADMIN.EXE $(WASD_EXE)HTTPDMON.EXE \
	$(WASD_EXE)MD5DIGEST.EXE $(WASD_EXE)PROXYMUNGE.EXE $(WASD_EXE)QDLOGSTATS.EXE $(WASD_EXE)RANDSEED.EXE $(WASD_EXE)SECHAN.EXE \
	[-.STARTUP]WASTEE_$(PLATFORM).EXE $(WASD_EXE)WOTSUP.EXE

WEBSOCKET = $(WASD_EXE)AUTOBAHN.EXE $(WASD_EXE)WSB.EXE $(WASD_EXE)WS_BENCH.EXE $(WASD_EXE)WS_CHAT.EXE $(WASD_EXE)WS_ECHO.EXE \
	$(WASD_EXE)WS_MOUSE.EXE $(WASD_EXE)RAW_CHAT.EXE $(WASD_EXE)RAW_ECHO.EXE $(WASD_EXE)RAW_PTD.EXE 

#
EXES =	$(HTTPD) $(AGENTS) $(CGIPLUS) $(MISC1) $(MISC2) $(OSU) $(QUERY) $(MISC3) \
	$(WASD_EXE)WASDOC.EXE $(UTILS) $(WEBSOCKET)

OBJ_ONLY = $(EXPATOBJDIR)elements.obj $(EXPATOBJDIR)outline.obj $(UTILSOBJDIR)httpdmon.obj $(UTILSOBJDIR)qdlogstats.obj \
	$(AGENTOBJDIR)authagent_ldap_1.obj

#
# Build Targets
#
build BUILD : $(OBJDIR)first.h $(EXES) $(LIBMISC_AS_IS) $(LIBMISC_UPPER) $(OBJ_ONLY)
	@ continue

clean CLEAN :
	@ $(ECHO) "   Deleting all target files..."
	@ PIPE $(DELETE_TREE) [.$(PLATFORM)...]*.*;* ; $(DELETE) $(PLATFORM).DIR;1
	@ PIPE $(DELETE) [-.$(PLATFORM)]*.EXE;*,*.DLL;*,[-.$(PLATFORM)-bin]*.EXE;*,[-.startup]wastee_$(PLATFORM).EXE;* > NL: 2> NL: ; x=1
	@ PIPE $(DELETE) [.*.obj_$(PLATFORM)]*.*;*,[.*]OBJ_$(PLATFORM).DIR;1 > NL: 2> NL: ; x=1

#
# Build instructions for each object library
#
$(LIBEXPAT) : $(LIBEXPAT)($(LIBEXPAT_OBJS))
	@ continue

$(LIBHTTPD) : $(LIBHTTPD)($(LIBHTTPD_OBJS))
	@ continue

$(LIBMISC) : $(LIBMISC)($(LIBMISC_OBJS))
	@ continue

$(LIBMISC_AS_IS) : $(LIBMISC_AS_IS)($(LIBMISC_OBJS))
	@ continue

$(LIBMISC_UPPER) : $(LIBMISC_UPPER)($(LIBMISC_UPPER_OBJS))
	@ continue

$(LIBOSU) : $(LIBOSU)($(LIBOSU_OBJS))
	@ continue

$(LIBWASDOC) : $(LIBWASDOC)($(LIBWASDOC_OBJS))
	@ continue

$(LIBWEBSOCKET) : $(LIBWEBSOCKET)($(LIBWEBSOCKET_OBJS))
	@ continue

#
# Build instructions for each executable
#
LINK_DEFAULT = 	$(LINK)/EXE=$(MMS$TARGET)$(LINKFLAGS) $(MMS$SOURCE_LIST)/LIBRARY
LINK_OPT =	$(LINK)/EXE=$(MMS$TARGET)$(LINKFLAGS) $(MMS$SOURCE_LIST)/OPTIONS
LINK_LIB_OPT =  $(LINK)/EXE=$(MMS$TARGET)$(LINKFLAGS) $(SUBST $(LIBMISC),$(LIBMISC)/LIBRARY,$(MMS$SOURCE_LIST))/OPTIONS
LINK_OBJS =	$(LINK)/EXE=$(MMS$TARGET)$(LINKFLAGS) $(MMS$SOURCE_LIST)

#
#----AGENTS-----
#
$(WASD_EXE)AUTHAGENT_CEL.EXE : $(AGENTOBJDIR)authagent_cel.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)AUTHAGENT_EXAMPLE.EXE : $(AGENTOBJDIR)authagent_example.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)AUTHAGENT_LDAP.EXE : $(AGENTOBJDIR)authagent_ldap_2.obj $(LIBMISC) $(OBJDIR)ssl.opt
	$(LINK_LIB_OPT)
$(WASD_EXE)ACCAGENT.EXE : $(AGENTOBJDIR)accagent.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)LOOKAGENT.EXE : $(AGENTOBJDIR)lookagent.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)METAGENT.EXE : $(AGENTOBJDIR)metagent.obj $(LIBMISC)
	$(LINK_DEFAULT)

#
#----CGIPLUS-----
#
$(WASD_EXE)CGIPLUSDEMO.EXE : $(CGIPLUSOBJDIR)cgiplusdemo.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)CGIPLUSLOOP.EXE : $(CGIPLUSOBJDIR)cgiplusloop.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)CGIPLUSSKEL.EXE : $(CGIPLUSOBJDIR)cgiplusskel.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)CGICALLOUT.EXE : $(CGIPLUSOBJDIR)cgicallout.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)CGIPLUSCALLOUT.EXE : $(CGIPLUSOBJDIR)cgipluscallout.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)CGISAPI.EXE : $(CGIPLUSOBJDIR)cgisapi.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)CGIPLUSTEST.EXE : $(CGIPLUSOBJDIR)cgiplustest.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)ISAPIEXAMPLE.DLL : $(CGIPLUSOBJDIR)isapiexample.obj $(LIBMISC) $(OBJDIR)isapi.opt
	$(LINK)/SHARE=$(MMS$TARGET)$(LINKFLAGS)/NOTRACE $(MMS$SOURCE),$(LIBMISC)/LIBRARY,$(OBJDIR)isapi.opt/opt
$(WASD_EXE)RTE_EXAMPLE.EXE : $(CGIPLUSOBJDIR)rte_example.obj $(LIBMISC)
	$(LINK_DEFAULT)

#
#----HTTPD-----
#
$(WASD_EXE)ELEMENTS.EXE : $(EXPATOBJDIR)elements.obj $(LIBEXPAT)
	$(LINK_DEFAULT)
$(WASD_EXE)OUTLINE.EXE : $(EXPATOBJDIR)outline.obj $(LIBEXPAT)
	$(LINK_DEFAULT)
$(WASD_EXE)HTTPD_SSL.EXE : $(HTTPDOBJDIR)httpd.obj $(LIBHTTPD) $(LIBEXPAT) $(OBJDIR)httpd.opt
	$(LINK)/NOTRACE/EXE=$(MMS$TARGET)$(LINKFLAGS) $(MMS$SOURCE),$(OBJDIR)httpd.opt/opt
$(CGI_EXE)CGILIBSHR32.EXE : $(LIBMISC) [.misc]cgilibshr.opt
	$(LINK)/NOTRACE/SHARE=$(MMS$TARGET)$(LINKFLAGS) [.misc]cgilibshr.opt/opt,$(LIBMISC)/Library

#
#----MISC1-----
#
$(WASD_EXE)CONAN.EXE : $(CONANOBJDIR)conan.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)HYPERREADER.EXE : $(HYPERREADEROBJDIR)hyperreader.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)HYPERSHELF.EXE : $(HYPERREADEROBJDIR)hypershelf.obj $(LIBMISC)
	$(LINK_DEFAULT)

#
#----MISC2-----
#
$(WASD_EXE)CGILIB_EXAMPLE.EXE : $(MISCOBJDIR)cgilib_example.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)CGIUTL.EXE : $(MISCOBJDIR)cgiutl.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)CHKACC.EXE : $(MISCOBJDIR)chkacc.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)FETCH.EXE : $(MISCOBJDIR)fetch.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)FORMWORK.EXE : $(MISCOBJDIR)formwork.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)IPCTICKLER.EXE : $(MISCOBJDIR)ipctickler.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)LINER.EXE : $(MISCOBJDIR)liner.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)MEMBUFDEMO.EXE : $(MISCOBJDIR)membufdemo.obj $(MISCOBJDIR)membuflib.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)TMAILER.EXE : $(MISCOBJDIR)tmailer.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)REPORTERROR.EXE : $(MISCOBJDIR)reporterror.obj $(LIBMISC)
	$(LINK_DEFAULT)

#
#----MISC3-----
#
$(WASD_EXE)SADHOC.EXE : $(SCREPEROBJDIR)sadhoc.obj $(SCREPEROBJDIR)screper.obj
	$(LINK_OBJS)
$(WASD_EXE)SHTTPDMON.EXE : $(SCREPEROBJDIR)shttpdmon.obj $(SCREPEROBJDIR)screper.obj
	$(LINK_OBJS)
$(WASD_EXE)SMONITOR.EXE : $(SCREPEROBJDIR)smonitor.obj $(SCREPEROBJDIR)screper.obj
	$(LINK_OBJS)
$(WASD_EXE)SOPCOM.EXE : $(SCREPEROBJDIR)sopcom.obj $(SCREPEROBJDIR)screper.obj
	$(LINK_OBJS)

#
#----OSU-----
#
$(WASD_EXE)CGI_SYMBOLS.EXE : $(OSUOBJDIR)cgi_symbols.obj $(LIBOSU)
	$(LINK_DEFAULT)
$(WASD_EXE)CGI-MAILTO.EXE : $(OSUOBJDIR)cgi-mailto.obj $(LIBOSU)
	$(LINK_DEFAULT)
$(WASD_EXE)HTML_PREPROC.EXE : $(OSUOBJDIR)html_preproc.obj $(LIBOSU)
	$(LINK_DEFAULT)
$(WASD_EXE)SET_DCL_ENV.EXE : $(OSUOBJDIR)set_dcl_env.obj $(LIBOSU)
	$(LINK_DEFAULT)
$(WASD_EXE)OSU_TESTCGI.EXE : $(OSUOBJDIR)testcgi.obj $(LIBOSU)
	$(LINK_DEFAULT)
$(WASD_EXE)OSU_TESTFORM.EXE : $(OSUOBJDIR)testform.obj $(LIBOSU)
	$(LINK_DEFAULT)
$(WASD_EXE)TMAIL.EXE : $(OSUOBJDIR)tmail.obj $(LIBOSU)
	$(LINK_DEFAULT)
$(WASD_EXE)VMSHELPGATE.EXE : $(OSUOBJDIR)vmshelpgate.obj $(LIBOSU)
	$(LINK_DEFAULT)
$(WASD_EXE)WEBBOOK.EXE : $(OSUOBJDIR)webbook.obj $(LIBOSU)
	$(LINK_DEFAULT)

#
#----QUERY-----
#
$(WASD_EXE)EXTRACT.EXE : $(QUERYOBJDIR)extract.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)QUERY.EXE : $(QUERYOBJDIR)query.obj $(LIBMISC)
	$(LINK_DEFAULT)

#
#----UTILS-----
#
$(WASD_EXE)CALOGS.EXE : $(UTILSOBJDIR)calogs.obj $(OBJDIR)sort.opt
	$(LINK_OPT)
$(WASD_EXE)CSPREPORT.EXE : $(UTILSOBJDIR)cspreport.obj $(LIBMISC)
	$(LINK_DEFAULT)
$(WASD_EXE)GEOLOCATE.EXE : $(UTILSOBJDIR)geolocate.obj $(LIBMISC) $(OBJDIR)ssl.opt
	$(LINK_LIB_OPT)
$(WASD_EXE)HTADMIN.EXE : $(UTILSOBJDIR)htadmin.obj $(HTTPDOBJDIR)md5.obj $(OBJDIR)sort.opt
	$(LINK_OPT)
$(WASD_EXE)HTTPDMON.EXE : $(UTILSOBJDIR)httpdmon_geolocate.obj $(UTILSOBJDIR)geolocate_object.obj $(LIBMISC) $(OBJDIR)ssl.opt
	$(LINK_LIB_OPT)
$(WASD_EXE)MD5DIGEST.EXE : $(UTILSOBJDIR)md5digest.obj
	$(LINK_OBJS)
$(WASD_EXE)PROXYMUNGE.EXE : $(UTILSOBJDIR)proxymunge.obj $(LIBMISC) $(OBJDIR)ssl.opt
	$(LINK_LIB_OPT)
$(WASD_EXE)QDLOGSTATS.EXE : $(UTILSOBJDIR)qdlogstats_geolocate.obj $(UTILSOBJDIR)geolocate_object.obj $(HTTPDOBJDIR)regex.obj $(LIBMISC) $(OBJDIR)ssl.opt
	$(LINK_LIB_OPT)
$(WASD_EXE)RANDSEED.EXE : $(UTILSOBJDIR)randseed.obj $(OBJDIR)spishr.opt
	$(LINK_OPT)
$(WASD_EXE)SECHAN.EXE : $(UTILSOBJDIR)sechan.obj
	$(LINK_OBJS)
[-.STARTUP]WASTEE_$(PLATFORM).EXE : $(UTILSOBJDIR)wastee.obj
	$(LINK_OBJS)
$(WASD_EXE)WOTSUP.EXE : $(UTILSOBJDIR)wotsup.obj
	$(LINK_OBJS)

#
#----WASDOC-----
#
$(WASD_EXE)WASDOC.EXE : $(WASDOCOBJDIR)wasdoc.obj $(LIBWASDOC)
	$(LINK_DEFAULT)

#
#----WEBSOCKET-----
#
$(WASD_EXE)AUTOBAHN.EXE : $(WEBSOCKETOBJDIR)autobahn.obj $(WEBSOCKETOBJDIR)wslib.obj $(WEBSOCKETOBJDIR)wslibcl.obj $(LIBHTTPD)
	$(LINK_DEFAULT)
$(WASD_EXE)WSB.EXE : $(WEBSOCKETOBJDIR)wsb.obj $(WEBSOCKETOBJDIR)wslib.obj $(WEBSOCKETOBJDIR)wslibcl.obj $(LIBHTTPD)
	$(LINK_DEFAULT)
$(WASD_EXE)WS_BENCH.EXE : $(WEBSOCKETOBJDIR)ws_bench.obj $(WEBSOCKETOBJDIR)wslib.obj 
	$(LINK_OBJS)
$(WASD_EXE)WS_CHAT.EXE : $(WEBSOCKETOBJDIR)ws_chat.obj $(WEBSOCKETOBJDIR)wslib.obj 
	$(LINK_OBJS)
$(WASD_EXE)WS_ECHO.EXE : $(WEBSOCKETOBJDIR)ws_echo.obj $(WEBSOCKETOBJDIR)wslib.obj 
	$(LINK_OBJS)
$(WASD_EXE)WS_MOUSE.EXE : $(WEBSOCKETOBJDIR)ws_mouse.obj $(WEBSOCKETOBJDIR)wslib.obj 
	$(LINK_OBJS)
$(WASD_EXE)RAW_CHAT.EXE : $(WEBSOCKETOBJDIR)raw_chat.obj $(WEBSOCKETOBJDIR)rawlib.obj 
	$(LINK_OBJS)
$(WASD_EXE)RAW_ECHO.EXE : $(WEBSOCKETOBJDIR)raw_echo.obj $(WEBSOCKETOBJDIR)rawlib.obj 
	$(LINK_OBJS)
$(WASD_EXE)RAW_PTD.EXE : $(WEBSOCKETOBJDIR)raw_ptd.obj $(WEBSOCKETOBJDIR)rawlib.obj 
	$(LINK_OBJS)

#
# Generated files
#
$(OBJDIR)first.h : DESCRIP.MMS
	@ hopenssl = f$parse("OPENSSL") - ".;"
	@ CREATE/FDL="FILE;ORGANIZATION sequential;RECORD;CARRIAGE_CONTROL carriage_return; FORMAT stream_lf" $@
	@ OPEN/APPEND OFILE $@
	@ WRITE OFILE "#ifndef __cplusplus"
	@ WRITE OFILE "#pragma message disable EMPTYFILE"
	@ WRITE OFILE "#pragma message disable IMPLICITFUNC"
	@ WRITE OFILE "#pragma message disable CVTDIFTYPES"
	@ WRITE OFILE "#pragma message disable PTRMISMATCH"
	@ WRITE OFILE "#endif"
	@ WRITE OFILE "#pragma include_directory ""./expat"""
	@ WRITE OFILE "#define lib$vm_calloc LIB$VM_CALLOC"
	@ WRITE OFILE "#define lib$vm_free LIB$VM_FREE"
	@ WRITE OFILE "#define exe$getspi EXE$GETSPI
	@ WRITE OFILE "#define HAVE_EXPAT_CONFIG_H 1"
	@ WRITE OFILE "#define SESOLA 1"
	@ WRITE OFILE "#define WATCH_CAT 1"
	@ WRITE OFILE "#define WATCH_MOD 0"
	@ WRITE OFILE "#define WASD_ACME 1"
	@ WRITE OFILE "#define WASD_GETSPI 1"
	@ WRITE OFILE "#define HOPENSSL ""''hopenssl'"""
	@ WRITE OFILE "#define STDC_HEADERS 1"
	@ WRITE OFILE "#define REGEX_MALLOC 1"
	@ WRITE OFILE "#define LIB_SSL_32 ""''LIB_SSL_32'"""
	@ WRITE OFILE "#define BUILD_DATETIME __DATE__ "" "" __TIME__"
	@ WRITE OFILE "#include <starlet.h>"
	@ WRITE OFILE "#include <lib$routines.h>"
	@ CLOSE OFILE

$(OBJDIR)httpd.opt : DESCRIP.MMS
	@ CREATE/FDL="FILE;ORGANIZATION sequential;RECORD;CARRIAGE_CONTROL carriage_return; FORMAT stream_lf" $@
	@ OPEN/APPEND OFILE $@
	@ WRITE OFILE "!"
	@ WRITE OFILE "! Image Ident"
	@ WRITE OFILE "!"
	@ WRITE OFILE "IDENTIFICATION=""WASD"""
	@ WRITE OFILE "NAME=""HTTPD_SSL"""
	@ WRITE OFILE "BUILD_IDENT=""''IMAGE_IDENT'"""
	@ WRITE OFILE "CASE_SENSITIVE=YES"
	@ WRITE OFILE "SYMBOL=SESOLA_SHARE,''SESOLA_SHARE'"
	@ WRITE OFILE "!"
	@ WRITE OFILE "! Object Libraries"
	@ WRITE OFILE "!"
	@ WRITE OFILE "$(LIBHTTPD)/LIBRARY
	@ WRITE OFILE "$(LIBEXPAT)/LIBRARY
	@ WRITE OFILE "!"
	@ WRITE OFILE "! Shareable Libraries"
	@ WRITE OFILE "!"
	@ WRITE OFILE "''SSL_LIBSSL_LIB'"
	@ WRITE OFILE "''SSL_LIBCRYPTO_LIB'"
	@ WRITE OFILE "$(SPISHR)/SHARE"
	@ WRITE OFILE "!""
	@ CLOSE OFILE

$(OBJDIR)ssl.opt : DESCRIP.MMS
	@ CREATE/FDL="FILE;ORGANIZATION sequential;RECORD;CARRIAGE_CONTROL carriage_return; FORMAT stream_lf" $@
	@ OPEN/APPEND OFILE $@
	@ WRITE OFILE "!"
	@ WRITE OFILE "! Shareable Libraries"
	@ WRITE OFILE "!"
	@ WRITE OFILE "''SSL_LIBSSL_LIB'"
	@ WRITE OFILE "''SSL_LIBCRYPTO_LIB'"
	@ WRITE OFILE "!""
	@ CLOSE OFILE

$(OBJDIR)isapi.opt : DESCRIP.MMS
	@ CREATE/FDL="FILE;ORGANIZATION sequential;RECORD;CARRIAGE_CONTROL carriage_return; FORMAT stream_lf" $@
	@ OPEN/APPEND OFILE $@
	@ WRITE OFILE "IDENTIFICATION=""WASD"""
	@ WRITE OFILE "NAME=""ISAPI"""
	@ WRITE OFILE "BUILD_IDENT=""''IMAGE_IDENT'"""
	@ WRITE OFILE "CASE_SENSITIVE=YES"
	@ WRITE OFILE "SYMBOL_VECTOR=(GetExtensionVersion=PROCEDURE,HttpExtensionProc=PROCEDURE)"
	@ CLOSE OFILE

$(OBJDIR)spishr.opt : DESCRIP.MMS
	@ CREATE/FDL="FILE;ORGANIZATION sequential;RECORD;CARRIAGE_CONTROL carriage_return; FORMAT stream_lf" $@
	@ OPEN/APPEND OFILE $@
	@ WRITE OFILE "!"
	@ WRITE OFILE "! Shareable Libraries"
	@ WRITE OFILE "!"
	@ WRITE OFILE "$(SPISHR)/SHARE"
	@ WRITE OFILE "!""
	@ CLOSE OFILE

$(OBJDIR)sort.opt : DESCRIP.MMS
	@ CREATE/FDL="FILE;ORGANIZATION sequential;RECORD;CARRIAGE_CONTROL carriage_return; FORMAT stream_lf" $@
	@ OPEN/APPEND OFILE $@
	@ WRITE OFILE "!"
	@ WRITE OFILE "! Shareable Libraries"
	@ WRITE OFILE "!"
	@ WRITE OFILE "$(SORTSHR)/SHARE"
	@ WRITE OFILE "!""
	@ CLOSE OFILE

#
# C dependencies
#
$(AGENTOBJDIR)accagent.obj : [.agent]accagent.c [.misc]cgilib.h
$(AGENTOBJDIR)authagent_cel.obj : [.agent]authagent_cel.c [.misc]cgilib.h
$(AGENTOBJDIR)authagent_example.obj : [.agent]authagent_example.c [.misc]cgilib.h
$(AGENTOBJDIR)authagent_ldap_1.obj : [.agent]authagent_ldap_1.c [.misc]cgilib.h
$(AGENTOBJDIR)authagent_ldap_2.obj : [.agent]authagent_ldap_2.c [.misc]cgilib.h
$(AGENTOBJDIR)lookagent.obj : [.agent]lookagent.c [.misc]cgilib.h
$(AGENTOBJDIR)metagent.obj : [.agent]metagent.c [.misc]cgilib.h

$(CGIPLUSOBJDIR)cgicallout.obj : [.cgiplus]cgicallout.c
$(CGIPLUSOBJDIR)cgipluscallout.obj : [.cgiplus]cgipluscallout.c [.misc]cgilib.h
$(CGIPLUSOBJDIR)cgiplusdemo.obj : [.cgiplus]cgiplusdemo.c [.misc]cgilib.h
$(CGIPLUSOBJDIR)cgiplusloop.obj : [.cgiplus]cgiplusloop.c
$(CGIPLUSOBJDIR)cgiplusskel.obj : [.cgiplus]cgiplusskel.c [.misc]cgilib.h
$(CGIPLUSOBJDIR)cgiplustest.obj : [.cgiplus]cgiplustest.c [.misc]cgilib.h
$(CGIPLUSOBJDIR)cgiplus_cgivar.obj : [.cgiplus]cgiplus_cgivar.c
$(CGIPLUSOBJDIR)cgisapi.obj : [.cgiplus]cgisapi.c [.cgiplus]cgisapi.h [.misc]cgilib.h
$(CGIPLUSOBJDIR)isapiexample.obj : [.cgiplus]isapiexample.c [.cgiplus]cgisapi.h
$(CGIPLUSOBJDIR)rte_example.obj : [.cgiplus]rte_example.c [.misc]cgilib.h

$(CONANOBJDIR)conan.obj : [.conan]conan.c [.conan]enamel.h [.misc]cgilib.h

$(EXPATOBJDIR)benchmark.obj : [.expat]benchmark.c
$(EXPATOBJDIR)chardata.obj : [.expat]chardata.c [.expat]minicheck.h [.expat]chardata.h [.expat]expat.h [.expat]expat_external.h
$(EXPATOBJDIR)elements.obj : [.expat]elements.c [.expat]expat.h [.expat]expat_external.h
$(EXPATOBJDIR)memcheck.obj : [.expat]memcheck.c [.expat]memcheck.h
$(EXPATOBJDIR)minicheck.obj : [.expat]minicheck.c [.expat]internal.h [.expat]minicheck.h
$(EXPATOBJDIR)outline.obj : [.expat]outline.c [.expat]expat.h [.expat]expat_external.h
$(EXPATOBJDIR)runtests.obj : [.expat]runtests.c
$(EXPATOBJDIR)structdata.obj : [.expat]structdata.c [.expat]expat_config.h [.expat]structdata.h [.expat]expat.h [.expat]expat_external.h [.expat]minicheck.h
$(EXPATOBJDIR)xmlparse.obj : [.expat]xmlparse.c [.expat]ascii.h [.expat]expat.h [.expat]expat_external.h [.expat]siphash.h [.expat]internal.h [.expat]xmltok.h [.expat]xmlrole.h
$(EXPATOBJDIR)xmlrole.obj : [.expat]xmlrole.c [.expat]ascii.h [.expat]expat_external.h [.expat]internal.h [.expat]xmlrole.h [.expat]xmltok.h
$(EXPATOBJDIR)xmltok.obj : [.expat]xmltok.c [.expat]ascii.h [.expat]asciitab.h [.expat]expat_external.h [.expat]iasciitab.h [.expat]internal.h [.expat]latin1tab.h [.expat]nametab.h [.expat]utf8tab.h [.expat]xmltok.c [.expat]xmltok.h [.expat]xmltok_impl.c [.expat]xmltok_impl.h [.expat]xmltok_ns.c
$(EXPATOBJDIR)xmltok_impl.obj : [.expat]xmltok_impl.c 
$(EXPATOBJDIR)xmltok_ns.obj : [.expat]xmltok_ns.c

$(HTTPDOBJDIR)admin.obj : [.httpd]admin.c $(WASD_H)
$(HTTPDOBJDIR)auth.obj : [.httpd]auth.c $(WASD_H)
$(HTTPDOBJDIR)authaccess.obj : [.httpd]authaccess.c $(WASD_H)
$(HTTPDOBJDIR)authacme.obj : [.httpd]authacme.c $(WASD_H)
$(HTTPDOBJDIR)authagent.obj : [.httpd]authagent.c $(WASD_H)
$(HTTPDOBJDIR)authcache.obj : [.httpd]authcache.c $(WASD_H)
$(HTTPDOBJDIR)authconfig.obj : [.httpd]authconfig.c $(WASD_H)
$(HTTPDOBJDIR)authhta.obj : [.httpd]authhta.c $(WASD_H)
$(HTTPDOBJDIR)authhtl.obj : [.httpd]authhtl.c $(WASD_H)
$(HTTPDOBJDIR)authident.obj : [.httpd]authident.c $(WASD_H)
$(HTTPDOBJDIR)authtoken.obj : [.httpd]authtoken.c $(WASD_H)
$(HTTPDOBJDIR)authvms.obj : [.httpd]authvms.c $(WASD_H)
$(HTTPDOBJDIR)base64.obj : [.httpd]base64.c [.httpd]base64.h
$(HTTPDOBJDIR)basic.obj : [.httpd]basic.c $(WASD_H)
$(HTTPDOBJDIR)body.obj : [.httpd]body.c $(WASD_H)
$(HTTPDOBJDIR)cache.obj : [.httpd]cache.c $(WASD_H)
$(HTTPDOBJDIR)cgi.obj : [.httpd]cgi.c $(WASD_H)
$(HTTPDOBJDIR)cli.obj : [.httpd]cli.c $(WASD_H)
$(HTTPDOBJDIR)config.obj : [.httpd]config.c $(WASD_H)
$(HTTPDOBJDIR)control.obj : [.httpd]control.c $(WASD_H)
$(HTTPDOBJDIR)davcopy.obj : [.httpd]davcopy.c $(WASD_H)
$(HTTPDOBJDIR)davdelete.obj : [.httpd]davdelete.c $(WASD_H)
$(HTTPDOBJDIR)davlock.obj : [.httpd]davlock.c $(WASD_H)
$(HTTPDOBJDIR)davmeta.obj : [.httpd]davmeta.c $(WASD_H)
$(HTTPDOBJDIR)davmove.obj : [.httpd]davmove.c $(WASD_H)
$(HTTPDOBJDIR)davprop.obj : [.httpd]davprop.c $(WASD_H)
$(HTTPDOBJDIR)davweb.obj : [.httpd]davweb.c $(WASD_H)
$(HTTPDOBJDIR)davxml.obj : [.httpd]davxml.c $(WASD_H)
$(HTTPDOBJDIR)dcl.obj : [.httpd]dcl.c $(WASD_H)
$(HTTPDOBJDIR)dclmembuf.obj : [.httpd]dclmembuf.c $(WASD_H)
$(HTTPDOBJDIR)decnet.obj : [.httpd]decnet.c $(WASD_H)
$(HTTPDOBJDIR)descr.obj : [.httpd]descr.c $(WASD_H)
$(HTTPDOBJDIR)dict.obj : [.httpd]dict.c $(WASD_H)
$(HTTPDOBJDIR)digest.obj : [.httpd]digest.c $(WASD_H)
$(HTTPDOBJDIR)dir.obj : [.httpd]dir.c $(WASD_H)
$(HTTPDOBJDIR)error.obj : [.httpd]error.c $(WASD_H)
$(HTTPDOBJDIR)fao.obj : [.httpd]fao.c $(WASD_H)
$(HTTPDOBJDIR)file.obj : [.httpd]file.c $(WASD_H)
$(HTTPDOBJDIR)graph.obj : [.httpd]graph.c $(WASD_H)
$(HTTPDOBJDIR)gzip.obj : [.httpd]gzip.c $(WASD_H)
$(HTTPDOBJDIR)hpack.obj : [.httpd]hpack.c $(WASD_H)
$(HTTPDOBJDIR)htadmin.obj : [.httpd]htadmin.c $(WASD_H)
$(HTTPDOBJDIR)http2.obj : [.httpd]http2.c $(WASD_H)
$(HTTPDOBJDIR)http2net.obj : [.httpd]http2net.c $(WASD_H)
$(HTTPDOBJDIR)http2request.obj : [.httpd]http2request.c $(WASD_H)
$(HTTPDOBJDIR)http2watch.obj : [.httpd]http2watch.c $(WASD_H)
$(HTTPDOBJDIR)httpd.obj : [.httpd]httpd.c $(WASD_H)
$(HTTPDOBJDIR)inconfig.obj : [.httpd]inconfig.c $(WASD_H)
$(HTTPDOBJDIR)instance.obj : [.httpd]instance.c $(WASD_H)
$(HTTPDOBJDIR)logging.obj : [.httpd]logging.c $(WASD_H)
$(HTTPDOBJDIR)mapcon.obj : [.httpd]mapcon.c $(WASD_H)
$(HTTPDOBJDIR)mapods.obj : [.httpd]mapods.c $(WASD_H)
$(HTTPDOBJDIR)mapset.obj : [.httpd]mapset.c $(WASD_H)
$(HTTPDOBJDIR)mapurl.obj : [.httpd]mapurl.c $(WASD_H)
$(HTTPDOBJDIR)mapuser.obj : [.httpd]mapuser.c $(WASD_H)
$(HTTPDOBJDIR)md5.obj : [.httpd]md5.c
$(HTTPDOBJDIR)metacon.obj : [.httpd]metacon.c $(WASD_H)
$(HTTPDOBJDIR)msg.obj : [.httpd]msg.c $(WASD_H)
$(HTTPDOBJDIR)net.obj : [.httpd]net.c $(WASD_H)
$(HTTPDOBJDIR)netio.obj : [.httpd]netio.c $(WASD_H)
$(HTTPDOBJDIR)netreject.obj : [.httpd]netreject.c $(WASD_H)
$(HTTPDOBJDIR)ods.obj : [.httpd]ods.c $(WASD_H)
$(HTTPDOBJDIR)persona.obj : [.httpd]persona.c $(WASD_H)
$(HTTPDOBJDIR)proxy.obj : [.httpd]proxy.c $(WASD_H)
$(HTTPDOBJDIR)proxyftp.obj : [.httpd]proxyftp.c $(WASD_H)
$(HTTPDOBJDIR)proxymaint.obj : [.httpd]proxymaint.c $(WASD_H)
$(HTTPDOBJDIR)proxynet.obj : [.httpd]proxynet.c $(WASD_H)
$(HTTPDOBJDIR)proxyrework.obj : [.httpd]proxyrework.c $(WASD_H)
$(HTTPDOBJDIR)proxysocks.obj : [.httpd]proxysocks.c $(WASD_H)
$(HTTPDOBJDIR)proxytunnel.obj : [.httpd]proxytunnel.c $(WASD_H)
$(HTTPDOBJDIR)proxyverify.obj : [.httpd]proxyverify.c $(WASD_H)
$(HTTPDOBJDIR)put.obj : [.httpd]put.c $(WASD_H)
$(HTTPDOBJDIR)redirect.obj : [.httpd]redirect.c $(WASD_H)
$(HTTPDOBJDIR)regex.obj : [.httpd]regex.c [.httpd]regex.h
$(HTTPDOBJDIR)request.obj : [.httpd]request.c $(WASD_H)
$(HTTPDOBJDIR)response.obj : [.httpd]response.c $(WASD_H)
$(HTTPDOBJDIR)service.obj : [.httpd]service.c $(WASD_H)
$(HTTPDOBJDIR)sesola.obj : [.httpd]sesola.c [.httpd]Sesola.h $(WASD_H)
$(HTTPDOBJDIR)sesolacache.obj : [.httpd]sesolacache.c [.httpd]Sesola.h $(WASD_H)
$(HTTPDOBJDIR)sesolacert.obj : [.httpd]sesolacert.c [.httpd]Sesola.h $(WASD_H)
$(HTTPDOBJDIR)sesolacgi.obj : [.httpd]sesolacgi.c [.httpd]Sesola.h $(WASD_H)
$(HTTPDOBJDIR)sesolaclient.obj : [.httpd]sesolaclient.c [.httpd]Sesola.h $(WASD_H)
$(HTTPDOBJDIR)sesolamkcert.obj : [.httpd]sesolamkcert.c [.httpd]Sesola.h $(WASD_H)
$(HTTPDOBJDIR)sesolanet.obj : [.httpd]sesolanet.c [.httpd]Sesola.h $(WASD_H)
$(HTTPDOBJDIR)sesolanetio.obj : [.httpd]sesolanetio.c [.httpd]Sesola.h $(WASD_H)
$(HTTPDOBJDIR)sha1.obj : [.httpd]sha1.c [.httpd]sha1.h
$(HTTPDOBJDIR)ssi.obj : [.httpd]ssi.c $(WASD_H)
$(HTTPDOBJDIR)stmlf.obj : [.httpd]stmlf.c $(WASD_H)
$(HTTPDOBJDIR)strdsc.obj : [.httpd]strdsc.c $(WASD_H)
$(HTTPDOBJDIR)strng.obj : [.httpd]strng.c $(WASD_H)
$(HTTPDOBJDIR)support.obj : [.httpd]support.c $(WASD_H)
$(HTTPDOBJDIR)syslog.obj : [.httpd]syslog.c $(WASD_H)
$(HTTPDOBJDIR)sysplus.obj : [.httpd]sysplus.c $(WASD_H)
$(HTTPDOBJDIR)tcpip.obj : [.httpd]tcpip.c $(WASD_H)
$(HTTPDOBJDIR)tcpip6.obj : [.httpd]tcpip6.c $(WASD_H)
$(HTTPDOBJDIR)tcpipalt.obj : [.httpd]tcpipalt.c $(WASD_H)
$(HTTPDOBJDIR)throttle.obj : [.httpd]throttle.c $(WASD_H)
$(HTTPDOBJDIR)upd.obj : [.httpd]upd.c $(WASD_H)
$(HTTPDOBJDIR)version.obj : [.httpd]version.c $(WASD_H)
$(HTTPDOBJDIR)vm.obj : [.httpd]vm.c $(WASD_H)
$(HTTPDOBJDIR)watch.obj : [.httpd]watch.c $(WASD_H)
$(HTTPDOBJDIR)websock.obj : [.httpd]websock.c $(WASD_H)

$(HYPERREADEROBJDIR)hyperreader.obj : [.hyperreader]hyperreader.c [.hyperreader]enamel.h [.hyperreader]hyperreader.h [.misc]cgilib.h
$(HYPERREADEROBJDIR)hypershelf.obj : [.hyperreader]hypershelf.c [.hyperreader]enamel.h [.hyperreader]hyperreader.h [.misc]cgilib.h

$(MISCOBJDIR)cgilib.obj : [.misc]cgilib.c [.misc]cgilib.h
$(MISCOBJDIR)cgilib_upper.obj : [.misc]cgilib.c [.misc]cgilib.h
	$(CC)$(CC_OPT)$(CFLAGS)$(LISTFLAG)$(EXTRAFLAGS)/OBJECT=$(MMS$TARGET)/NAMES=UPPER $(MMS$SOURCE)
$(MISCOBJDIR)cgilib_example.obj : [.misc]cgilib_example.c [.misc]cgilib.h
$(MISCOBJDIR)cgiutl.obj : [.misc]cgiutl.c [.misc]cgilib.h
$(MISCOBJDIR)chkacc.obj : [.misc]chkacc.c
$(MISCOBJDIR)connect_example.obj : [.misc]connect_example.c
$(MISCOBJDIR)fetch.obj : [.misc]fetch.c [.misc]cgilib.h
$(MISCOBJDIR)formwork.obj : [.misc]formwork.c [.misc]cgilib.h
$(MISCOBJDIR)ipctickler.obj : [.misc]ipctickler.c
$(MISCOBJDIR)liner.obj : [.misc]liner.c [.misc]cgilib.h
$(MISCOBJDIR)membufdemo.obj : [.misc]membufdemo.c [.misc]membuflib.h
$(MISCOBJDIR)membuflib.obj : [.misc]membuflib.c [.misc]membuflib.h
$(MISCOBJDIR)membuflib_upper.obj : [.misc]membuflib.c [.misc]membuflib.h
	$(CC)$(CC_OPT)$(CFLAGS)$(LISTFLAG)$(EXTRAFLAGS)/OBJECT=$(MMS$TARGET)/NAMES=UPPER $(MMS$SOURCE)
$(MISCOBJDIR)reporterror.obj : [.misc]reporterror.c [.misc]cgilib.h
$(MISCOBJDIR)tmailer.obj : [.misc]tmailer.c [.misc]cgilib.h

$(OSUOBJDIR)access_db.obj : [.osu]access_db.c [.osu]access_db.h
$(OSUOBJDIR)bookfile_figure.obj : [.osu]bookfile_figure.c [.osu]bookfile_figure.h [.osu]bookreader_recdef.h
$(OSUOBJDIR)bookfile_index.obj : [.osu]bookfile_index.c [.osu]bookreader_recdef.h [.osu]bookfile_io.h [.osu]bookfile_index.h
$(OSUOBJDIR)bookfile_io.obj : [.osu]bookfile_io.c [.osu]bookreader_recdef.h [.osu]bookfile_io.h 
$(OSUOBJDIR)bookfile_section.obj : [.osu]bookfile_section.c [.osu]bookreader_recdef.h [.osu]bookfile_io.h [.osu]bookfile_section.h
$(OSUOBJDIR)bookfile_text.obj : [.osu]bookfile_text.c [.osu]bookreader_recdef.h [.osu]bookfile_io.h [.osu]bookfile_text.h
$(OSUOBJDIR)cgi-mailto.obj : [.osu]cgi-mailto.c [.osu]cgi-mailto.h [.osu]cgilib.h
$(OSUOBJDIR)cgilib.obj : [.osu]cgilib.c [.osu]cgilib.h [.osu]scriptlib.h
$(OSUOBJDIR)cgi_symbols.obj : [.osu]cgi_symbols.c [.osu]cgilib.h [.osu]scriptlib.h
$(OSUOBJDIR)html_preproc.obj : [.osu]html_preproc.c [.osu]scriptlib.h [.osu]access_db.h
$(OSUOBJDIR)lbrio.obj : [.osu]lbrio.c [.osu]lbrio.h
$(OSUOBJDIR)scriptlib.obj : [.osu]scriptlib.c [.osu]scriptlib.h
$(OSUOBJDIR)set_dcl_env.obj : [.osu]set_dcl_env.c [.osu]cgilib.h [.osu]scriptlib.h
$(OSUOBJDIR)testcgi.obj : [.osu]testcgi.c [.osu]cgilib.h
$(OSUOBJDIR)testform.obj : [.osu]testform.c [.osu]cgilib.h
$(OSUOBJDIR)tmail.obj : [.osu]tmail.c [.osu]cgilib.h
$(OSUOBJDIR)vmshelpgate.obj : [.osu]vmshelpgate.c [.osu]lbrio.h [.osu]cgilib.h
$(OSUOBJDIR)webbook.obj : [.osu]webbook.c [.osu]scriptlib.h [.osu]cgilib.h [.osu]bookreader_recdef.h [.osu]bookfile_io.h [.osu]bookfile_index.h [.osu]bookfile_section.h [.osu]bookfile_text.h [.osu]bookfile_figure.h
$(OSUOBJDIR)webbook_shelf.obj : [.osu]webbook_shelf.c [.osu]cgilib.h

$(QUERYOBJDIR)extract.obj : [.query]extract.c [.query]enamel.h [.query]query.h [.misc]cgilib.h
$(QUERYOBJDIR)query.obj : [.query]query.c [.query]enamel.h [.query]query.h [.misc]cgilib.h

$(SCREPEROBJDIR)sadhoc.obj : [.screper]sadhoc.c [.screper]screper.h
$(SCREPEROBJDIR)screper.obj : [.screper]screper.c [.screper]screper.h
$(SCREPEROBJDIR)shttpdmon.obj : [.screper]shttpdmon.c [.screper]screper.h
$(SCREPEROBJDIR)smonitor.obj : [.screper]smonitor.c [.screper]screper.h
$(SCREPEROBJDIR)sopcom.obj : [.screper]sopcom.c [.screper]screper.h

$(UTILSOBJDIR)calogs.obj : [.utils]calogs.c
$(UTILSOBJDIR)ccdcnt.obj : [.utils]ccdcnt.c
$(UTILSOBJDIR)cspreport.obj : [.utils]cspreport.c [.misc]cgilib.h
$(UTILSOBJDIR)geolocate.obj : [.utils]geolocate.c [.utils]geolocate.h
$(UTILSOBJDIR)geolocate_object.obj : [.utils]geolocate.c [.utils]geolocate.h
	$(CC)$(CC_OPT)$(CFLAGS)$(LISTFLAG)$(EXTRAFLAGS)/OBJECT=$(MMS$TARGET)/DEFINE=(HTTPDMON_GEOLOCATE=1,GEOLOCATE_OBJECT=1) $(MMS$SOURCE)
$(UTILSOBJDIR)htadmin.obj : [.utils]htadmin.c $(WASD_H)
$(UTILSOBJDIR)httpdmon.obj : [.utils]httpdmon.c $(WASD_H)
$(UTILSOBJDIR)httpdmon_geolocate.obj : [.utils]httpdmon.c $(WASD_H)
	$(CC)$(CC_OPT)$(CFLAGS)$(LISTFLAG)$(EXTRAFLAGS)/OBJECT=$(MMS$TARGET)/DEFINE=(HTTPDMON_GEOLOCATE=1,GEOLOCATE_OBJECT=1) $(MMS$SOURCE)
$(UTILSOBJDIR)md5digest.obj : [.httpd]md5.c
	$(CC)$(CC_OPT)$(CFLAGS)$(LISTFLAG)$(EXTRAFLAGS)/OBJECT=$(MMS$TARGET)/DEFINE=MD5DIGEST $(MMS$SOURCE)
$(UTILSOBJDIR)proxymunge.obj : [.utils]proxymunge.c [.misc]cgilib.h
$(UTILSOBJDIR)qdlogstats.obj : [.utils]qdlogstats.c
$(UTILSOBJDIR)qdlogstats_geolocate.obj : [.utils]qdlogstats.c
	$(CC)$(CC_OPT)$(CFLAGS)$(LISTFLAG)$(EXTRAFLAGS)/OBJECT=$(MMS$TARGET)/DEFINE=(QDLOGSTATS_GEOLOCATE) $(MMS$SOURCE)
$(UTILSOBJDIR)randseed.obj : [.utils]randseed.c
$(UTILSOBJDIR)sechan.obj : [.utils]sechan.c [.utils]enamel.h
$(UTILSOBJDIR)wastee.obj : [.utils]wastee.c
$(UTILSOBJDIR)wotsup.obj : [.utils]wotsup.c $(WASD_H)

$(WASDOCOBJDIR)cgi.obj : [.wasdoc]cgi.c [.wasdoc]wasdoc.h [.wasdoc]cgilib.h
$(WASDOCOBJDIR)cgilib.obj : [.wasdoc]cgilib.c [.wasdoc]cgilib.h
$(WASDOCOBJDIR)cli.obj : [.wasdoc]cli.c [.wasdoc]wasdoc.h
$(WASDOCOBJDIR)draw.obj : [.wasdoc]draw.c [.wasdoc]wasdoc.h [.wasdoc]cgilib.h
$(WASDOCOBJDIR)pass2.obj : [.wasdoc]pass2.c [.wasdoc]wasdoc.h [.wasdoc]cgilib.h
$(WASDOCOBJDIR)regex.obj : [.wasdoc]regex.c [.wasdoc]regex.h
$(WASDOCOBJDIR)render.obj : [.wasdoc]render.c [.wasdoc]wasdoc.h [.wasdoc]cgilib.h [.wasdoc]CSS.H
$(WASDOCOBJDIR)spawn.obj : [.wasdoc]spawn.c [.wasdoc]wasdoc.h
$(WASDOCOBJDIR)test.obj : [.wasdoc]test.c [.wasdoc]wasdoc.h [.wasdoc]regex.h
$(WASDOCOBJDIR)wasdoc.obj : [.wasdoc]wasdoc.c [.wasdoc]wasdoc.h [.wasdoc]cgilib.h

$(WEBSOCKETOBJDIR)autobahn.obj : [.websocket]autobahn.c [.websocket]wslib.h
$(WEBSOCKETOBJDIR)rawlib.obj : [.websocket]rawlib.c [.websocket]rawlib.h
$(WEBSOCKETOBJDIR)raw_chat.obj : [.websocket]raw_chat.c [.websocket]rawlib.h
$(WEBSOCKETOBJDIR)raw_echo.obj : [.websocket]raw_echo.c [.websocket]rawlib.h
$(WEBSOCKETOBJDIR)raw_ptd.obj : [.websocket]raw_ptd.c [.websocket]rawlib.h
$(WEBSOCKETOBJDIR)wsb.obj : [.websocket]wsb.c [.websocket]wslib.h
$(WEBSOCKETOBJDIR)wslib.obj : [.websocket]wslib.c [.websocket]wslib.h
$(WEBSOCKETOBJDIR)wslibcl.obj : [.websocket]wslibcl.c [.websocket]wslib.h [.httpd]base64.h [.httpd]sha1.h
$(WEBSOCKETOBJDIR)ws_bench.obj : [.websocket]ws_bench.c [.websocket]wslib.h
$(WEBSOCKETOBJDIR)ws_chat.obj : [.websocket]ws_chat.c [.websocket]wslib.h
$(WEBSOCKETOBJDIR)ws_echo.obj : [.websocket]ws_echo.c [.websocket]wslib.h
$(WEBSOCKETOBJDIR)ws_mouse.obj : [.websocket]ws_mouse.c [.websocket]wslib.h
