$!-----------------------------------------------------------------------------
$! BUILD_OSU.COM
$! Builds the OSU example scripts for both VAX and AXP systems (separately)
$!
$! P1 == BUILD or LINK
$! P1 == "DELETE" deletes those scripts from WASD_EXE ;^)
$!
$! 23-NOV-2022  MGD  /STANDARD=RELAXED_ANSI /NAMES=AS_IS
$! 12-AUG-1998  MGD  updated to v3.3a, added HTML_PREPROC.COM
$! 07-JAN-1998  MGD  initial development
$!-----------------------------------------------------------------------------
$!
$ ON CONTROLY THEN EXIT 44
$!
$ @WASD_ROOT:[SRC]ARCHER.COM "OSU"
$!
$ DEFINES = " /DEFINE=(__VMS_VER=70000000,__CRTL_VER=70000000)"
$ CC_OPTIONS = "/STANDARD=RELAXED_ANSI /PREFIX=ALL /NAMES=AS_IS " +-
               "/WARNING=DISABLE=(PREOPTW)" +-
               DEFINES + "/OBJECT=" + WASD_OBJ_DIR
$!
$ IF P1 .EQS. "" .OR. P1 .EQS. "BUILD" .OR. P1 .EQS. "COMPILE"
$ THEN
$    SET NOON
$    SET VERIFY
$!
$!   (support modules)
$    CC 'CC_OPTIONS' CGILIB.C
$    CC 'CC_OPTIONS' LBRIO.C
$    CC 'CC_OPTIONS' SCRIPTLIB.C
$!
$!   (various executables)
$    CC 'CC_OPTIONS' CGI_SYMBOLS.C
$    CC 'CC_OPTIONS' CGI-MAILTO.C
$    CC 'CC_OPTIONS' SET_DCL_ENV.C
$    CC 'CC_OPTIONS' TESTCGI.C
$    CC 'CC_OPTIONS' TESTFORM.C
$    CC 'CC_OPTIONS' TMAIL.C
$    CC 'CC_OPTIONS' VMSHELPGATE.C
$!
$!   (bookreader application)
$    CC 'CC_OPTIONS' WEBBOOK.C
$    CC 'CC_OPTIONS' BOOKFILE_SECTION.C
$    CC 'CC_OPTIONS' BOOKFILE_INDEX.C
$    CC 'CC_OPTIONS' BOOKFILE_TEXT.C
$    CC 'CC_OPTIONS' BOOKFILE_IO.C
$    CC 'CC_OPTIONS' BOOKFILE_FIGURE.C
$    CC 'CC_OPTIONS' WEBBOOK_SHELF.C
$!
$!   (HTML pre-processor)
$    CC 'CC_OPTIONS' ACCESS_DB.C
$    CC 'CC_OPTIONS' HTML_PREPROC.C
$!
$!   'F$VERIFY(0)
$    SET ON
$ ENDIF
$!
$ IF P1 .EQS. "" .OR. P1 .EQS. "BUILD" .OR. P1 .EQS. "LINK"
$ THEN
$    SET NOON
$    SET VERIFY
$    LINK /EXECUTABLE=WASD_EXE:CGI_SYMBOLS.EXE -
          'WASD_OBJ_DIR'CGI_SYMBOLS, -
          'WASD_OBJ_DIR'CGILIB , -
          'WASD_OBJ_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=WASD_EXE:CGI-MAILTO.EXE -
          'WASD_OBJ_DIR'CGI-MAILTO, -
          'WASD_OBJ_DIR'CGILIB , -
          'WASD_OBJ_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=WASD_EXE:HTML_PREPROC.EXE -
          'WASD_OBJ_DIR'HTML_PREPROC, -
          'WASD_OBJ_DIR'ACCESS_DB , -
          'WASD_OBJ_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=WASD_EXE:SET_DCL_ENV.EXE -
          'WASD_OBJ_DIR'SET_DCL_ENV, -
          'WASD_OBJ_DIR'CGILIB , -
          'WASD_OBJ_DIR'SCRIPTLIB
$    COPY DCL_ENV_RM.COM WASD_EXE:
$    LINK /EXECUTABLE=WASD_EXE:OSU_TESTCGI.EXE -
          'WASD_OBJ_DIR'TESTCGI, -
          'WASD_OBJ_DIR'CGILIB , -
          'WASD_OBJ_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=WASD_EXE:OSU_TESTFORM.EXE -
          'WASD_OBJ_DIR'TESTFORM, -
          'WASD_OBJ_DIR'CGILIB , -
          'WASD_OBJ_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=WASD_EXE:TMAIL.EXE -
          'WASD_OBJ_DIR'TMAIL, -
          'WASD_OBJ_DIR'CGILIB , -
          'WASD_OBJ_DIR'SCRIPTLIB
$    LINK /EXECUTABLE=WASD_EXE:VMSHELPGATE.EXE -
          'WASD_OBJ_DIR'VMSHELPGATE, -
          'WASD_OBJ_DIR'CGILIB , -
          'WASD_OBJ_DIR'LBRIO, -
          'WASD_OBJ_DIR'SCRIPTLIB
$    COPY HELPGATE.COM WASD_EXE:
$!
$    LINK /EXECUTABLE=WASD_EXE:WEBBOOK.EXE WEBBOOK_'WASD_ARCH_NAME'.OPT/OPTION
$!
$    COPY CGIWASD.COM WASD_EXE:
$    COPY HTML_PREPROC.COM WASD_EXE:
$    COPY WWWEXEC.COM WASD_EXE:
$!
$!   'F$VERIFY(0)
$    SET ON
$    PURGE /NOLOG 'WASD_OBJ_DIR'
$ ENDIF
$!
$ IF P1 .EQS. "DELETE"
$ THEN
$    SET NOON
$    SET VERIFY
$    DELETE WASD_EXE:HTML_PREPROC.EXE;*
$    DELETE WASD_EXE:HTML_PREPROC.COM;*
$    DELETE WASD_EXE:SET_DCL_ENV.EXE;*
$    DELETE WASD_EXE:DCL_ENV_RM.COM;*
$    DELETE WASD_EXE:OSU_TESTCGI.EXE;*
$    DELETE WASD_EXE:OSU_TESTFORM.EXE;*
$    DELETE WASD_EXE:TMAIL.EXE;*
$    DELETE WASD_EXE:VMSHELPGATE.EXE;*
$    DELETE WASD_EXE:HELPGATE.COM;*
$    DELETE WASD_EXE:WEBBOOK.EXE;*
$!   'F$VERIFY(0)
$    SET ON
$ ENDIF
$!
$!-----------------------------------------------------------------------------
